﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Net;
using System.Net.Http;

namespace WebApi客户端加密身份验证
{
    public partial class frmClient : Form
    {
        public frmClient()
        {
            InitializeComponent();
        }

        private void btnWebapi_Click(object sender, EventArgs e)
        {
            if (txtBaseUrl.Text == "" || txtRelativeUrl.Text == "") { txtInfo.AppendText("接口链接不完整"); return; }
            string url = txtBaseUrl.Text.Trim() + txtRelativeUrl.Text.Trim();
            string Parameter = "";
            string Scheme = txtScheme.Text;//scheme不用加密
            if (txtParameter.Text != "")
            {
                Parameter = DES1.Encrypt(txtParameter.Text);
                //Parameter = DES.Encrypt(txtParameter.Text);
                //Parameter = Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(txtParameter.Text));//转成base64字符串
            }
            txtInfo.AppendText(Parameter+"\n");
            txtInfo.AppendText(HttpWithAuthorize(url,Scheme,Parameter));
            
        }
        public static string HttpWithAuthorize(string url, string scheme,string parameter)
        {
            HttpClient client = new HttpClient();
            HttpRequestMessage reqMessage = new HttpRequestMessage();
            Uri thisUri = new Uri(url);
            reqMessage.Method = HttpMethod.Get;
            reqMessage.RequestUri = thisUri;
            reqMessage.Headers.Authorization = new System.Net.Http.Headers.AuthenticationHeaderValue(scheme, parameter);

            ServicePointManager.ServerCertificateValidationCallback = (sender, certificate, chain, sslPolicyErrors) => true;
            HttpResponseMessage resp = client.SendAsync(reqMessage).Result;
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("响应码：" + resp.StatusCode);
            sb.AppendLine("返回值：" + resp.Content.ReadAsStringAsync().Result);
            return sb.ToString();
        }
    }
}
